#include <pthread.h>
#include <stdio.h>
#include <semaphore.h>

sem_t semaphore;
sem_t limit;
pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

int queue[10];
int queueLength;

void *producer( void * param)
{
  for ( int i=0; i<500; i++ )
  {
    // Wait for space
    sem_wait( &limit );
    // Add item to queue
    pthread_mutex_lock( &mutex );
    queue[ queueLength++ ] = i;
    pthread_mutex_unlock( &mutex ); 
    // Signal semaphore
    sem_post( &semaphore );
  }
}

void *consumer(void * param)
{
  for ( int i=0; i<500; i++ )
  {
    int item;
    // Wait if nothing in queue
    if (queueLength==0) { sem_wait(&semaphore); }

    pthread_mutex_lock( &mutex );
    item = queue[ --queueLength ];
    pthread_mutex_unlock( &mutex );
    printf( "Received %i\n", item);
    sem_post( &limit );
  }
}

void main()
{
  pthread_t threads[2];  
  sem_init( &semaphore, 0, 0 );
  sem_init( &limit, 0, 10 );
  pthread_create( &threads[0], 0, producer, 0 );
  pthread_create( &threads[1], 0, consumer, 0 );
  pthread_join( threads[0], 0 );
  pthread_join( threads[1], 0 );
  sem_destroy( &limit );
  sem_destroy( &semaphore );
}
