#include <windows.h>
#include <process.h>

CONDITION_VARIABLE CV;
CRITICAL_SECTION CS;

int queue[200];
int queueLength=0;

void addItemToQueue(int v)
{
  if (queueLength>199) {printf("Queue exceeds available length\n"); exit(1);}
  queue[queueLength]=v;
  queueLength++;
}

int removeItemFromQueue()
{
  if (queueLength==0) {printf("No items in queue\n"); exit(1);}
  queueLength--;
  return queue[queueLength+1];
}

void addItem( int value )
{
  LONG oldQueueLength;
  EnterCriticalSection( &CS );
  oldQueueLength = queueLength;
  addItemToQueue( value );
  LeaveCriticalSection( &CS );
  if ( oldQueueLength==0 )         // If the queue was empty
  {
     WakeConditionVariable( &CV ); // Wake one sleeping thread
  }
}

int removeItem()
{
  int item;
  EnterCriticalSection( &CS );
  while ( queueLength==0 )         // If the queue is empty
  { 
     SleepConditionVariableCS( &CV, &CS, INFINITE );   // Sleep
  }
  item = removeItemFromQueue();
  LeaveCriticalSection( &CS );
  return item;
}

unsigned int __stdcall addItems( void * )
{
  for ( int counter=0; counter<100; counter++ )
  {
    addItemToQueue( counter );
  }
  return 0;
}

unsigned int __stdcall removeItems( void * )
{
  for ( int counter=0; counter<100; counter++ )
  {
    int item = removeItemFromQueue();
    printf( "%i got %i \n", counter, item);
  }
  return 0;
}


void _tmain()
{
  HANDLE h1, h2;
  InitializeCriticalSection( &CS );
  InitializeConditionVariable( &CV );
  h1 = (HANDLE)_beginthreadex( 0, 0, &addItems, (void*)0, 0, 0);
  h2 = (HANDLE)_beginthreadex( 0, 0, &removeItems, (void*)0, 0, 0);
  WaitForSingleObject( h1, INFINITE );
  WaitForSingleObject( h2, INFINITE );
  CloseHandle( h1 );
  CloseHandle( h2 );  
  DeleteCriticalSection( &CS );
}
