#include <stdio.h>
#include <pthread.h>

volatile int volatile buffer[16];
volatile int addhere;
volatile int removehere;

#ifdef __sparc
int CAS( volatile int* addr, int ov, int nv)
{
  asm volatile( "cas %1, %2, %0": 
                "=r"(nv): 
                "m"(*addr),"r"(ov),"0"(nv):
                "memory" );
  return nv;
}
#else
int CAS( volatile int* addr, int ov, int nv )
{
  asm volatile( "lock; cmpxchg %2, %1":
                "=a"(ov):
                "m"(*addr),"r"(nv),"a"(ov):
                "memory" );
  return ov;
}
#endif

void clearbuffer()
{
  addhere = 0;
  removehere = 0;
  for( int i=0; i<16; i++ ) { buffer[i] = 0; }
}

int next( int current )
{
  return ( current + 1 ) & 15;
}

void addtobuffer( int value )
{
  int success = 0;
  while ( !success )
  {
    if ( buffer[ next(addhere) ] == 0 )
    {
      if ( CAS( &buffer[ next(addhere) ], 0, value ) == 0 )
      {
        addhere = next(addhere);
        success = 1;
      }
    }
  }
}

int removefrombuffer()
{
  int value;
  int success = 0;
  while ( !success )
  {
    if ( ( value = buffer[removehere] ) != 0 )
    {
      if ( CAS( &buffer[removehere], value, 0 ) == value )
      {
        removehere = next(removehere);
        success = 1;
      }
    }
  }
  return value;
}

void * producer( void *param )
{
  for( int i=1; i<10000000; i++ )
  {
    addtobuffer( i );
  }
}

void * consumer ( void *param )
{
  while ( removefrombuffer() != 9999999 ) {}
}

int main()
{
  clearbuffer();
  pthread_t threads[2];
  pthread_create( &threads[0], 0, producer, 0 );
  pthread_create( &threads[1], 0, consumer, 0 );
  pthread_join( threads[1], 0 );
  pthread_join( threads[0], 0 );
}

