#include<stdio.h>

#ifdef __sparc
int CAS( volatile int* addr, int ov, int nv)
{
  asm volatile( "cas %1, %2, %0": 
                "=r"(nv): 
                "m"(*addr),"r"(ov),"0"(nv):
                "memory" );
  return nv;
}
#else
int CAS( volatile int* addr, int ov, int nv )
{
  asm volatile( "lock; cmpxchg %2, %1":
                "=a"(ov):
                "m"(*addr),"r"(nv),"a"(ov):
                "memory" );
  return ov;
}
#endif

void atomic_add_float( volatile float * variable, float increment )
{
  union
  {
    int asint; 
    float asfp;
  } oldvalue, newvalue;

  do
  {
     oldvalue.asfp = *variable;
     newvalue.asfp = oldvalue.asfp + increment;
  }
  while ( CAS( (int*)variable, oldvalue.asint, newvalue.asint )
          != oldvalue.asint );
}
int main()
{
  float value = 0.0;
  printf("value = %f\n", value );
  atomic_add_float( &value, 4.3 );
  printf("value = %f\n", value );

}
